<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ListAvailableCruises' => '\\StructType\\ListAvailableCruises',
            'ListAvailableCruisesResponse' => '\\StructType\\ListAvailableCruisesResponse',
            'ArrayOfCruise' => '\\ArrayType\\ArrayOfCruise',
            'Cruise' => '\\StructType\\Cruise',
            'Destination' => '\\StructType\\Destination',
            'AdditionaInfo' => '\\StructType\\AdditionaInfo',
            'Itinerary' => '\\StructType\\Itinerary',
            'ArrayOfSegment' => '\\ArrayType\\ArrayOfSegment',
            'Segment' => '\\StructType\\Segment',
            'City' => '\\StructType\\City',
            'Ship' => '\\StructType\\Ship',
            'ArrayOfCategory' => '\\ArrayType\\ArrayOfCategory',
            'Category' => '\\StructType\\Category',
            'ArrayOfGuestPrice' => '\\ArrayType\\ArrayOfGuestPrice',
            'GuestPrice' => '\\StructType\\GuestPrice',
            'ArrayOfDiscount' => '\\ArrayType\\ArrayOfDiscount',
            'Discount' => '\\StructType\\Discount',
            'DiscountPrice' => '\\StructType\\DiscountPrice',
            'ArrayOfSpecialServices' => '\\ArrayType\\ArrayOfSpecialServices',
            'SpecialServices' => '\\StructType\\SpecialServices',
            'SSVType' => '\\StructType\\SSVType',
            'SSVRates' => '\\StructType\\SSVRates',
            'SSVRules' => '\\StructType\\SSVRules',
            'SSVSellable' => '\\StructType\\SSVSellable',
            'SSVAvailable' => '\\StructType\\SSVAvailable',
            'PrintOnConfLetter' => '\\StructType\\PrintOnConfLetter',
            'VoucherInfo' => '\\StructType\\VoucherInfo',
            'DiscountPriceType' => '\\StructType\\DiscountPriceType',
            'CabinAvailabilityInfo' => '\\StructType\\CabinAvailabilityInfo',
            'ArrayOfScore' => '\\ArrayType\\ArrayOfScore',
            'Score' => '\\StructType\\Score',
            'ArrayOfPublicArea' => '\\ArrayType\\ArrayOfPublicArea',
            'PublicArea' => '\\StructType\\PublicArea',
            'ImmediateConfirm' => '\\StructType\\ImmediateConfirm',
            'ShoppingByPriceData' => '\\StructType\\ShoppingByPriceData',
            'Agency' => '\\StructType\\Agency',
            'Partner' => '\\StructType\\Partner',
            'ListAutomaticDiscounts' => '\\StructType\\ListAutomaticDiscounts',
            'ListAutomaticDiscountsResponse' => '\\StructType\\ListAutomaticDiscountsResponse',
            'ListAllDestinations' => '\\StructType\\ListAllDestinations',
            'ListAllDestinationsResponse' => '\\StructType\\ListAllDestinationsResponse',
            'ArrayOfDestination' => '\\ArrayType\\ArrayOfDestination',
            'ListAllShips' => '\\StructType\\ListAllShips',
            'ListAllShipsResponse' => '\\StructType\\ListAllShipsResponse',
            'ArrayOfShip' => '\\ArrayType\\ArrayOfShip',
            'ListAllPorts' => '\\StructType\\ListAllPorts',
            'ListAllPortsResponse' => '\\StructType\\ListAllPortsResponse',
            'ArrayOfCity' => '\\ArrayType\\ArrayOfCity',
            'ListShips' => '\\StructType\\ListShips',
            'ListShipsResponse' => '\\StructType\\ListShipsResponse',
            'ListPorts' => '\\StructType\\ListPorts',
            'ListPortsResponse' => '\\StructType\\ListPortsResponse',
            'ListFares' => '\\StructType\\ListFares',
            'ListFaresResponse' => '\\StructType\\ListFaresResponse',
            'ArrayOfFare' => '\\ArrayType\\ArrayOfFare',
            'Fare' => '\\StructType\\Fare',
            'PromoFlights' => '\\StructType\\PromoFlights',
            'ListAvailableCabins' => '\\StructType\\ListAvailableCabins',
            'ArrayOfComponent' => '\\ArrayType\\ArrayOfComponent',
            'Component' => '\\StructType\\Component',
            'Cabin' => '\\StructType\\Cabin',
            'ArrayOfBed' => '\\ArrayType\\ArrayOfBed',
            'Bed' => '\\StructType\\Bed',
            'RateInformation' => '\\StructType\\RateInformation',
            'ArrayOfDiningWith' => '\\ArrayType\\ArrayOfDiningWith',
            'DiningWith' => '\\StructType\\DiningWith',
            'ArrayOfGuestCabinInfo' => '\\ArrayType\\ArrayOfGuestCabinInfo',
            'GuestCabinInfo' => '\\StructType\\GuestCabinInfo',
            'RestaurantInfo' => '\\StructType\\RestaurantInfo',
            'ArrayOfDiningInformation' => '\\ArrayType\\ArrayOfDiningInformation',
            'DiningInformation' => '\\StructType\\DiningInformation',
            'ArrayOfHotel' => '\\ArrayType\\ArrayOfHotel',
            'Hotel' => '\\StructType\\Hotel',
            'ArrayOfRoomType' => '\\ArrayType\\ArrayOfRoomType',
            'RoomType' => '\\StructType\\RoomType',
            'ArrayOfRoomPrice' => '\\ArrayType\\ArrayOfRoomPrice',
            'RoomPrice' => '\\StructType\\RoomPrice',
            'ArrayOfTransportationDetail' => '\\ArrayType\\ArrayOfTransportationDetail',
            'TransportationDetail' => '\\StructType\\TransportationDetail',
            'CheckInInformation' => '\\StructType\\CheckInInformation',
            'ArrayOfGuest' => '\\ArrayType\\ArrayOfGuest',
            'Guest' => '\\StructType\\Guest',
            'GuestResidence' => '\\StructType\\GuestResidence',
            'GuestDocument' => '\\StructType\\GuestDocument',
            'GuestRevisionControl' => '\\StructType\\GuestRevisionControl',
            'ContactPhone' => '\\StructType\\ContactPhone',
            'ArrayOfGuestDocument' => '\\ArrayType\\ArrayOfGuestDocument',
            'ArrayOfMCHotel' => '\\ArrayType\\ArrayOfMCHotel',
            'MCHotel' => '\\StructType\\MCHotel',
            'OtherInfo' => '\\StructType\\OtherInfo',
            'ArrayOfMCTransportation' => '\\ArrayType\\ArrayOfMCTransportation',
            'MCTransportation' => '\\StructType\\MCTransportation',
            'MultiCruiseInsurance' => '\\StructType\\MultiCruiseInsurance',
            'ExtendedProperties' => '\\StructType\\ExtendedProperties',
            'WebCheckIn' => '\\StructType\\WebCheckIn',
            'EmercencyInfo' => '\\StructType\\EmercencyInfo',
            'AdditionalAdvertisingInfo' => '\\StructType\\AdditionalAdvertisingInfo',
            'ArrayOfSpecialItem' => '\\ArrayType\\ArrayOfSpecialItem',
            'SpecialItem' => '\\StructType\\SpecialItem',
            'PrivacyInfo' => '\\StructType\\PrivacyInfo',
            'ArrayOfCompensation' => '\\ArrayType\\ArrayOfCompensation',
            'Compensation' => '\\StructType\\Compensation',
            'Privacy' => '\\StructType\\Privacy',
            'PartnerLoyalty' => '\\StructType\\PartnerLoyalty',
            'TravelInfo' => '\\StructType\\TravelInfo',
            'ListAvailableCabinsResponse' => '\\StructType\\ListAvailableCabinsResponse',
            'ArrayOfCabin' => '\\ArrayType\\ArrayOfCabin',
            'ListAvailableCabinsWithGroupBooking' => '\\StructType\\ListAvailableCabinsWithGroupBooking',
            'ListAvailableCabinsWithGroupBookingResponse' => '\\StructType\\ListAvailableCabinsWithGroupBookingResponse',
            'ListAvailableCategories' => '\\StructType\\ListAvailableCategories',
            'ListAvailableCategoriesResponse' => '\\StructType\\ListAvailableCategoriesResponse',
            'ListAvailableCategoriesWithGroupBooking' => '\\StructType\\ListAvailableCategoriesWithGroupBooking',
            'ListAvailableCategoriesWithGroupBookingResponse' => '\\StructType\\ListAvailableCategoriesWithGroupBookingResponse',
            'ListAvailableSpecialServices' => '\\StructType\\ListAvailableSpecialServices',
            'ListAvailableSpecialServicesResponse' => '\\StructType\\ListAvailableSpecialServicesResponse',
            'GetCruise' => '\\StructType\\GetCruise',
            'GetCruiseResponse' => '\\StructType\\GetCruiseResponse',
            'ListDocuments' => '\\StructType\\ListDocuments',
            'ListDocumentsResponse' => '\\StructType\\ListDocumentsResponse',
            'ArrayOfCruiseDocument' => '\\ArrayType\\ArrayOfCruiseDocument',
            'CruiseDocument' => '\\StructType\\CruiseDocument',
            'GetFlightPromoPriceExists' => '\\StructType\\GetFlightPromoPriceExists',
            'GetFlightPromoPriceExistsResponse' => '\\StructType\\GetFlightPromoPriceExistsResponse',
            'IsCruiseInImmediateConfirmForFare' => '\\StructType\\IsCruiseInImmediateConfirmForFare',
            'IsCruiseInImmediateConfirmForFareResponse' => '\\StructType\\IsCruiseInImmediateConfirmForFareResponse',
        );
    }
}
