<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AdditionalAdvertisingInfo StructType
 * @subpackage Structs
 */
class AdditionalAdvertisingInfo extends AbstractStructBase
{
    /**
     * The SendAdvertisingCosta
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $SendAdvertisingCosta;
    /**
     * The SendAdvertisingNominative
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $SendAdvertisingNominative;
    /**
     * The SendAdvertisingPartnerCosta
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $SendAdvertisingPartnerCosta;
    /**
     * Constructor method for AdditionalAdvertisingInfo
     * @uses AdditionalAdvertisingInfo::setSendAdvertisingCosta()
     * @uses AdditionalAdvertisingInfo::setSendAdvertisingNominative()
     * @uses AdditionalAdvertisingInfo::setSendAdvertisingPartnerCosta()
     * @param bool $sendAdvertisingCosta
     * @param bool $sendAdvertisingNominative
     * @param bool $sendAdvertisingPartnerCosta
     */
    public function __construct($sendAdvertisingCosta = null, $sendAdvertisingNominative = null, $sendAdvertisingPartnerCosta = null)
    {
        $this
            ->setSendAdvertisingCosta($sendAdvertisingCosta)
            ->setSendAdvertisingNominative($sendAdvertisingNominative)
            ->setSendAdvertisingPartnerCosta($sendAdvertisingPartnerCosta);
    }
    /**
     * Get SendAdvertisingCosta value
     * @return bool
     */
    public function getSendAdvertisingCosta()
    {
        return $this->SendAdvertisingCosta;
    }
    /**
     * Set SendAdvertisingCosta value
     * @param bool $sendAdvertisingCosta
     * @return \StructType\AdditionalAdvertisingInfo
     */
    public function setSendAdvertisingCosta($sendAdvertisingCosta = null)
    {
        // validation for constraint: boolean
        if (!is_null($sendAdvertisingCosta) && !is_bool($sendAdvertisingCosta)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sendAdvertisingCosta)), __LINE__);
        }
        $this->SendAdvertisingCosta = $sendAdvertisingCosta;
        return $this;
    }
    /**
     * Get SendAdvertisingNominative value
     * @return bool
     */
    public function getSendAdvertisingNominative()
    {
        return $this->SendAdvertisingNominative;
    }
    /**
     * Set SendAdvertisingNominative value
     * @param bool $sendAdvertisingNominative
     * @return \StructType\AdditionalAdvertisingInfo
     */
    public function setSendAdvertisingNominative($sendAdvertisingNominative = null)
    {
        // validation for constraint: boolean
        if (!is_null($sendAdvertisingNominative) && !is_bool($sendAdvertisingNominative)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sendAdvertisingNominative)), __LINE__);
        }
        $this->SendAdvertisingNominative = $sendAdvertisingNominative;
        return $this;
    }
    /**
     * Get SendAdvertisingPartnerCosta value
     * @return bool
     */
    public function getSendAdvertisingPartnerCosta()
    {
        return $this->SendAdvertisingPartnerCosta;
    }
    /**
     * Set SendAdvertisingPartnerCosta value
     * @param bool $sendAdvertisingPartnerCosta
     * @return \StructType\AdditionalAdvertisingInfo
     */
    public function setSendAdvertisingPartnerCosta($sendAdvertisingPartnerCosta = null)
    {
        // validation for constraint: boolean
        if (!is_null($sendAdvertisingPartnerCosta) && !is_bool($sendAdvertisingPartnerCosta)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sendAdvertisingPartnerCosta)), __LINE__);
        }
        $this->SendAdvertisingPartnerCosta = $sendAdvertisingPartnerCosta;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AdditionalAdvertisingInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
