<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Discount StructType
 * @subpackage Structs
 */
class Discount extends AbstractStructBase
{
    /**
     * The Code
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Code;
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The Class
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Class;
    /**
     * The Image
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Image;
    /**
     * The Label
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Label;
    /**
     * The Order
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Order;
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * The Id
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Id;
    /**
     * The DiscountPrice
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DiscountPrice
     */
    public $DiscountPrice;
    /**
     * The AutoItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfSpecialServices
     */
    public $AutoItem;
    /**
     * The PriceType
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DiscountPriceType
     */
    public $PriceType;
    /**
     * Constructor method for Discount
     * @uses Discount::setCode()
     * @uses Discount::setDescription()
     * @uses Discount::setClass()
     * @uses Discount::setImage()
     * @uses Discount::setLabel()
     * @uses Discount::setOrder()
     * @uses Discount::setType()
     * @uses Discount::setId()
     * @uses Discount::setDiscountPrice()
     * @uses Discount::setAutoItem()
     * @uses Discount::setPriceType()
     * @param string $code
     * @param string $description
     * @param string $class
     * @param string $image
     * @param string $label
     * @param string $order
     * @param string $type
     * @param string $id
     * @param \StructType\DiscountPrice $discountPrice
     * @param \ArrayType\ArrayOfSpecialServices $autoItem
     * @param \StructType\DiscountPriceType $priceType
     */
    public function __construct($code = null, $description = null, $class = null, $image = null, $label = null, $order = null, $type = null, $id = null, \StructType\DiscountPrice $discountPrice = null, \ArrayType\ArrayOfSpecialServices $autoItem = null, \StructType\DiscountPriceType $priceType = null)
    {
        $this
            ->setCode($code)
            ->setDescription($description)
            ->setClass($class)
            ->setImage($image)
            ->setLabel($label)
            ->setOrder($order)
            ->setType($type)
            ->setId($id)
            ->setDiscountPrice($discountPrice)
            ->setAutoItem($autoItem)
            ->setPriceType($priceType);
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\Discount
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \StructType\Discount
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get Class value
     * @return string|null
     */
    public function getClass()
    {
        return $this->Class;
    }
    /**
     * Set Class value
     * @param string $class
     * @return \StructType\Discount
     */
    public function setClass($class = null)
    {
        // validation for constraint: string
        if (!is_null($class) && !is_string($class)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($class)), __LINE__);
        }
        $this->Class = $class;
        return $this;
    }
    /**
     * Get Image value
     * @return string|null
     */
    public function getImage()
    {
        return $this->Image;
    }
    /**
     * Set Image value
     * @param string $image
     * @return \StructType\Discount
     */
    public function setImage($image = null)
    {
        // validation for constraint: string
        if (!is_null($image) && !is_string($image)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($image)), __LINE__);
        }
        $this->Image = $image;
        return $this;
    }
    /**
     * Get Label value
     * @return string|null
     */
    public function getLabel()
    {
        return $this->Label;
    }
    /**
     * Set Label value
     * @param string $label
     * @return \StructType\Discount
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($label)), __LINE__);
        }
        $this->Label = $label;
        return $this;
    }
    /**
     * Get Order value
     * @return string|null
     */
    public function getOrder()
    {
        return $this->Order;
    }
    /**
     * Set Order value
     * @param string $order
     * @return \StructType\Discount
     */
    public function setOrder($order = null)
    {
        // validation for constraint: string
        if (!is_null($order) && !is_string($order)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($order)), __LINE__);
        }
        $this->Order = $order;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \StructType\Discount
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Id value
     * @return string|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param string $id
     * @return \StructType\Discount
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get DiscountPrice value
     * @return \StructType\DiscountPrice|null
     */
    public function getDiscountPrice()
    {
        return $this->DiscountPrice;
    }
    /**
     * Set DiscountPrice value
     * @param \StructType\DiscountPrice $discountPrice
     * @return \StructType\Discount
     */
    public function setDiscountPrice(\StructType\DiscountPrice $discountPrice = null)
    {
        $this->DiscountPrice = $discountPrice;
        return $this;
    }
    /**
     * Get AutoItem value
     * @return \ArrayType\ArrayOfSpecialServices|null
     */
    public function getAutoItem()
    {
        return $this->AutoItem;
    }
    /**
     * Set AutoItem value
     * @param \ArrayType\ArrayOfSpecialServices $autoItem
     * @return \StructType\Discount
     */
    public function setAutoItem(\ArrayType\ArrayOfSpecialServices $autoItem = null)
    {
        $this->AutoItem = $autoItem;
        return $this;
    }
    /**
     * Get PriceType value
     * @return \StructType\DiscountPriceType|null
     */
    public function getPriceType()
    {
        return $this->PriceType;
    }
    /**
     * Set PriceType value
     * @param \StructType\DiscountPriceType $priceType
     * @return \StructType\Discount
     */
    public function setPriceType(\StructType\DiscountPriceType $priceType = null)
    {
        $this->PriceType = $priceType;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Discount
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
