<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExtendedProperties StructType
 * @subpackage Structs
 */
class ExtendedProperties extends AbstractStructBase
{
    /**
     * The FakedBirthdateUsed
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $FakedBirthdateUsed;
    /**
     * The PrimaryContact
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $PrimaryContact;
    /**
     * Constructor method for ExtendedProperties
     * @uses ExtendedProperties::setFakedBirthdateUsed()
     * @uses ExtendedProperties::setPrimaryContact()
     * @param bool $fakedBirthdateUsed
     * @param bool $primaryContact
     */
    public function __construct($fakedBirthdateUsed = null, $primaryContact = null)
    {
        $this
            ->setFakedBirthdateUsed($fakedBirthdateUsed)
            ->setPrimaryContact($primaryContact);
    }
    /**
     * Get FakedBirthdateUsed value
     * @return bool
     */
    public function getFakedBirthdateUsed()
    {
        return $this->FakedBirthdateUsed;
    }
    /**
     * Set FakedBirthdateUsed value
     * @param bool $fakedBirthdateUsed
     * @return \StructType\ExtendedProperties
     */
    public function setFakedBirthdateUsed($fakedBirthdateUsed = null)
    {
        // validation for constraint: boolean
        if (!is_null($fakedBirthdateUsed) && !is_bool($fakedBirthdateUsed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($fakedBirthdateUsed)), __LINE__);
        }
        $this->FakedBirthdateUsed = $fakedBirthdateUsed;
        return $this;
    }
    /**
     * Get PrimaryContact value
     * @return bool
     */
    public function getPrimaryContact()
    {
        return $this->PrimaryContact;
    }
    /**
     * Set PrimaryContact value
     * @param bool $primaryContact
     * @return \StructType\ExtendedProperties
     */
    public function setPrimaryContact($primaryContact = null)
    {
        // validation for constraint: boolean
        if (!is_null($primaryContact) && !is_bool($primaryContact)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($primaryContact)), __LINE__);
        }
        $this->PrimaryContact = $primaryContact;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ExtendedProperties
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
