<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Fare StructType
 * @subpackage Structs
 */
class Fare extends AbstractStructBase
{
    /**
     * The Code
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Code;
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The IsAllowedToBeChanged
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $IsAllowedToBeChanged;
    /**
     * The AdditionalInfoRequired
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $AdditionalInfoRequired;
    /**
     * The PromoFlights
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PromoFlights
     */
    public $PromoFlights;
    /**
     * The SolutionIdAirPromo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SolutionIdAirPromo;
    /**
     * The BestFlightPrice
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $BestFlightPrice;
    /**
     * The SessionIdAirPromo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SessionIdAirPromo;
    /**
     * The Image
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Image;
    /**
     * The Label
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Label;
    /**
     * The Order
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Order;
    /**
     * Constructor method for Fare
     * @uses Fare::setCode()
     * @uses Fare::setDescription()
     * @uses Fare::setIsAllowedToBeChanged()
     * @uses Fare::setAdditionalInfoRequired()
     * @uses Fare::setPromoFlights()
     * @uses Fare::setSolutionIdAirPromo()
     * @uses Fare::setBestFlightPrice()
     * @uses Fare::setSessionIdAirPromo()
     * @uses Fare::setImage()
     * @uses Fare::setLabel()
     * @uses Fare::setOrder()
     * @param string $code
     * @param string $description
     * @param string $isAllowedToBeChanged
     * @param string $additionalInfoRequired
     * @param \StructType\PromoFlights $promoFlights
     * @param string $solutionIdAirPromo
     * @param string $bestFlightPrice
     * @param string $sessionIdAirPromo
     * @param string $image
     * @param string $label
     * @param string $order
     */
    public function __construct($code = null, $description = null, $isAllowedToBeChanged = null, $additionalInfoRequired = null, \StructType\PromoFlights $promoFlights = null, $solutionIdAirPromo = null, $bestFlightPrice = null, $sessionIdAirPromo = null, $image = null, $label = null, $order = null)
    {
        $this
            ->setCode($code)
            ->setDescription($description)
            ->setIsAllowedToBeChanged($isAllowedToBeChanged)
            ->setAdditionalInfoRequired($additionalInfoRequired)
            ->setPromoFlights($promoFlights)
            ->setSolutionIdAirPromo($solutionIdAirPromo)
            ->setBestFlightPrice($bestFlightPrice)
            ->setSessionIdAirPromo($sessionIdAirPromo)
            ->setImage($image)
            ->setLabel($label)
            ->setOrder($order);
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\Fare
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \StructType\Fare
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get IsAllowedToBeChanged value
     * @return string|null
     */
    public function getIsAllowedToBeChanged()
    {
        return $this->IsAllowedToBeChanged;
    }
    /**
     * Set IsAllowedToBeChanged value
     * @param string $isAllowedToBeChanged
     * @return \StructType\Fare
     */
    public function setIsAllowedToBeChanged($isAllowedToBeChanged = null)
    {
        // validation for constraint: string
        if (!is_null($isAllowedToBeChanged) && !is_string($isAllowedToBeChanged)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($isAllowedToBeChanged)), __LINE__);
        }
        $this->IsAllowedToBeChanged = $isAllowedToBeChanged;
        return $this;
    }
    /**
     * Get AdditionalInfoRequired value
     * @return string|null
     */
    public function getAdditionalInfoRequired()
    {
        return $this->AdditionalInfoRequired;
    }
    /**
     * Set AdditionalInfoRequired value
     * @param string $additionalInfoRequired
     * @return \StructType\Fare
     */
    public function setAdditionalInfoRequired($additionalInfoRequired = null)
    {
        // validation for constraint: string
        if (!is_null($additionalInfoRequired) && !is_string($additionalInfoRequired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($additionalInfoRequired)), __LINE__);
        }
        $this->AdditionalInfoRequired = $additionalInfoRequired;
        return $this;
    }
    /**
     * Get PromoFlights value
     * @return \StructType\PromoFlights|null
     */
    public function getPromoFlights()
    {
        return $this->PromoFlights;
    }
    /**
     * Set PromoFlights value
     * @param \StructType\PromoFlights $promoFlights
     * @return \StructType\Fare
     */
    public function setPromoFlights(\StructType\PromoFlights $promoFlights = null)
    {
        $this->PromoFlights = $promoFlights;
        return $this;
    }
    /**
     * Get SolutionIdAirPromo value
     * @return string|null
     */
    public function getSolutionIdAirPromo()
    {
        return $this->SolutionIdAirPromo;
    }
    /**
     * Set SolutionIdAirPromo value
     * @param string $solutionIdAirPromo
     * @return \StructType\Fare
     */
    public function setSolutionIdAirPromo($solutionIdAirPromo = null)
    {
        // validation for constraint: string
        if (!is_null($solutionIdAirPromo) && !is_string($solutionIdAirPromo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($solutionIdAirPromo)), __LINE__);
        }
        $this->SolutionIdAirPromo = $solutionIdAirPromo;
        return $this;
    }
    /**
     * Get BestFlightPrice value
     * @return string|null
     */
    public function getBestFlightPrice()
    {
        return $this->BestFlightPrice;
    }
    /**
     * Set BestFlightPrice value
     * @param string $bestFlightPrice
     * @return \StructType\Fare
     */
    public function setBestFlightPrice($bestFlightPrice = null)
    {
        // validation for constraint: string
        if (!is_null($bestFlightPrice) && !is_string($bestFlightPrice)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($bestFlightPrice)), __LINE__);
        }
        $this->BestFlightPrice = $bestFlightPrice;
        return $this;
    }
    /**
     * Get SessionIdAirPromo value
     * @return string|null
     */
    public function getSessionIdAirPromo()
    {
        return $this->SessionIdAirPromo;
    }
    /**
     * Set SessionIdAirPromo value
     * @param string $sessionIdAirPromo
     * @return \StructType\Fare
     */
    public function setSessionIdAirPromo($sessionIdAirPromo = null)
    {
        // validation for constraint: string
        if (!is_null($sessionIdAirPromo) && !is_string($sessionIdAirPromo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sessionIdAirPromo)), __LINE__);
        }
        $this->SessionIdAirPromo = $sessionIdAirPromo;
        return $this;
    }
    /**
     * Get Image value
     * @return string|null
     */
    public function getImage()
    {
        return $this->Image;
    }
    /**
     * Set Image value
     * @param string $image
     * @return \StructType\Fare
     */
    public function setImage($image = null)
    {
        // validation for constraint: string
        if (!is_null($image) && !is_string($image)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($image)), __LINE__);
        }
        $this->Image = $image;
        return $this;
    }
    /**
     * Get Label value
     * @return string|null
     */
    public function getLabel()
    {
        return $this->Label;
    }
    /**
     * Set Label value
     * @param string $label
     * @return \StructType\Fare
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($label)), __LINE__);
        }
        $this->Label = $label;
        return $this;
    }
    /**
     * Get Order value
     * @return string|null
     */
    public function getOrder()
    {
        return $this->Order;
    }
    /**
     * Set Order value
     * @param string $order
     * @return \StructType\Fare
     */
    public function setOrder($order = null)
    {
        // validation for constraint: string
        if (!is_null($order) && !is_string($order)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($order)), __LINE__);
        }
        $this->Order = $order;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Fare
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
