<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GuestRevisionControl StructType
 * @subpackage Structs
 */
class GuestRevisionControl extends AbstractStructBase
{
    /**
     * The RateChange
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $RateChange;
    /**
     * The SpecialServicesChanged
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $SpecialServicesChanged;
    /**
     * The HotelChange
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $HotelChange;
    /**
     * The TransportationChange
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $TransportationChange;
    /**
     * The NameChange
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $NameChange;
    /**
     * Constructor method for GuestRevisionControl
     * @uses GuestRevisionControl::setRateChange()
     * @uses GuestRevisionControl::setSpecialServicesChanged()
     * @uses GuestRevisionControl::setHotelChange()
     * @uses GuestRevisionControl::setTransportationChange()
     * @uses GuestRevisionControl::setNameChange()
     * @param bool $rateChange
     * @param bool $specialServicesChanged
     * @param bool $hotelChange
     * @param bool $transportationChange
     * @param bool $nameChange
     */
    public function __construct($rateChange = null, $specialServicesChanged = null, $hotelChange = null, $transportationChange = null, $nameChange = null)
    {
        $this
            ->setRateChange($rateChange)
            ->setSpecialServicesChanged($specialServicesChanged)
            ->setHotelChange($hotelChange)
            ->setTransportationChange($transportationChange)
            ->setNameChange($nameChange);
    }
    /**
     * Get RateChange value
     * @return bool
     */
    public function getRateChange()
    {
        return $this->RateChange;
    }
    /**
     * Set RateChange value
     * @param bool $rateChange
     * @return \StructType\GuestRevisionControl
     */
    public function setRateChange($rateChange = null)
    {
        // validation for constraint: boolean
        if (!is_null($rateChange) && !is_bool($rateChange)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($rateChange)), __LINE__);
        }
        $this->RateChange = $rateChange;
        return $this;
    }
    /**
     * Get SpecialServicesChanged value
     * @return bool
     */
    public function getSpecialServicesChanged()
    {
        return $this->SpecialServicesChanged;
    }
    /**
     * Set SpecialServicesChanged value
     * @param bool $specialServicesChanged
     * @return \StructType\GuestRevisionControl
     */
    public function setSpecialServicesChanged($specialServicesChanged = null)
    {
        // validation for constraint: boolean
        if (!is_null($specialServicesChanged) && !is_bool($specialServicesChanged)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($specialServicesChanged)), __LINE__);
        }
        $this->SpecialServicesChanged = $specialServicesChanged;
        return $this;
    }
    /**
     * Get HotelChange value
     * @return bool
     */
    public function getHotelChange()
    {
        return $this->HotelChange;
    }
    /**
     * Set HotelChange value
     * @param bool $hotelChange
     * @return \StructType\GuestRevisionControl
     */
    public function setHotelChange($hotelChange = null)
    {
        // validation for constraint: boolean
        if (!is_null($hotelChange) && !is_bool($hotelChange)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($hotelChange)), __LINE__);
        }
        $this->HotelChange = $hotelChange;
        return $this;
    }
    /**
     * Get TransportationChange value
     * @return bool
     */
    public function getTransportationChange()
    {
        return $this->TransportationChange;
    }
    /**
     * Set TransportationChange value
     * @param bool $transportationChange
     * @return \StructType\GuestRevisionControl
     */
    public function setTransportationChange($transportationChange = null)
    {
        // validation for constraint: boolean
        if (!is_null($transportationChange) && !is_bool($transportationChange)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($transportationChange)), __LINE__);
        }
        $this->TransportationChange = $transportationChange;
        return $this;
    }
    /**
     * Get NameChange value
     * @return bool
     */
    public function getNameChange()
    {
        return $this->NameChange;
    }
    /**
     * Set NameChange value
     * @param bool $nameChange
     * @return \StructType\GuestRevisionControl
     */
    public function setNameChange($nameChange = null)
    {
        // validation for constraint: boolean
        if (!is_null($nameChange) && !is_bool($nameChange)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($nameChange)), __LINE__);
        }
        $this->NameChange = $nameChange;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GuestRevisionControl
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
