<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListAvailableCategoriesWithGroupBooking StructType
 * @subpackage Structs
 */
class ListAvailableCategoriesWithGroupBooking extends AbstractStructBase
{
    /**
     * The components
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfComponent
     */
    public $components;
    /**
     * The guests
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfGuest
     */
    public $guests;
    /**
     * The groupBooking
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $groupBooking;
    /**
     * Constructor method for ListAvailableCategoriesWithGroupBooking
     * @uses ListAvailableCategoriesWithGroupBooking::setComponents()
     * @uses ListAvailableCategoriesWithGroupBooking::setGuests()
     * @uses ListAvailableCategoriesWithGroupBooking::setGroupBooking()
     * @param \ArrayType\ArrayOfComponent $components
     * @param \ArrayType\ArrayOfGuest $guests
     * @param string $groupBooking
     */
    public function __construct(\ArrayType\ArrayOfComponent $components = null, \ArrayType\ArrayOfGuest $guests = null, $groupBooking = null)
    {
        $this
            ->setComponents($components)
            ->setGuests($guests)
            ->setGroupBooking($groupBooking);
    }
    /**
     * Get components value
     * @return \ArrayType\ArrayOfComponent|null
     */
    public function getComponents()
    {
        return $this->components;
    }
    /**
     * Set components value
     * @param \ArrayType\ArrayOfComponent $components
     * @return \StructType\ListAvailableCategoriesWithGroupBooking
     */
    public function setComponents(\ArrayType\ArrayOfComponent $components = null)
    {
        $this->components = $components;
        return $this;
    }
    /**
     * Get guests value
     * @return \ArrayType\ArrayOfGuest|null
     */
    public function getGuests()
    {
        return $this->guests;
    }
    /**
     * Set guests value
     * @param \ArrayType\ArrayOfGuest $guests
     * @return \StructType\ListAvailableCategoriesWithGroupBooking
     */
    public function setGuests(\ArrayType\ArrayOfGuest $guests = null)
    {
        $this->guests = $guests;
        return $this;
    }
    /**
     * Get groupBooking value
     * @return string|null
     */
    public function getGroupBooking()
    {
        return $this->groupBooking;
    }
    /**
     * Set groupBooking value
     * @param string $groupBooking
     * @return \StructType\ListAvailableCategoriesWithGroupBooking
     */
    public function setGroupBooking($groupBooking = null)
    {
        // validation for constraint: string
        if (!is_null($groupBooking) && !is_string($groupBooking)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($groupBooking)), __LINE__);
        }
        $this->groupBooking = $groupBooking;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ListAvailableCategoriesWithGroupBooking
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
