<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListAvailableCruises StructType
 * @subpackage Structs
 */
class ListAvailableCruises extends AbstractStructBase
{
    /**
     * The from
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $from;
    /**
     * The to
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $to;
    /**
     * The destinationCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $destinationCode;
    /**
     * The shipCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $shipCode;
    /**
     * The portCode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $portCode;
    /**
     * Constructor method for ListAvailableCruises
     * @uses ListAvailableCruises::setFrom()
     * @uses ListAvailableCruises::setTo()
     * @uses ListAvailableCruises::setDestinationCode()
     * @uses ListAvailableCruises::setShipCode()
     * @uses ListAvailableCruises::setPortCode()
     * @param string $from
     * @param string $to
     * @param string $destinationCode
     * @param string $shipCode
     * @param string $portCode
     */
    public function __construct($from = null, $to = null, $destinationCode = null, $shipCode = null, $portCode = null)
    {
        $this
            ->setFrom($from)
            ->setTo($to)
            ->setDestinationCode($destinationCode)
            ->setShipCode($shipCode)
            ->setPortCode($portCode);
    }
    /**
     * Get from value
     * @return string
     */
    public function getFrom()
    {
        return $this->from;
    }
    /**
     * Set from value
     * @param string $from
     * @return \StructType\ListAvailableCruises
     */
    public function setFrom($from = null)
    {
        // validation for constraint: string
        if (!is_null($from) && !is_string($from)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($from)), __LINE__);
        }
        $this->from = $from;
        return $this;
    }
    /**
     * Get to value
     * @return string
     */
    public function getTo()
    {
        return $this->to;
    }
    /**
     * Set to value
     * @param string $to
     * @return \StructType\ListAvailableCruises
     */
    public function setTo($to = null)
    {
        // validation for constraint: string
        if (!is_null($to) && !is_string($to)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($to)), __LINE__);
        }
        $this->to = $to;
        return $this;
    }
    /**
     * Get destinationCode value
     * @return string|null
     */
    public function getDestinationCode()
    {
        return $this->destinationCode;
    }
    /**
     * Set destinationCode value
     * @param string $destinationCode
     * @return \StructType\ListAvailableCruises
     */
    public function setDestinationCode($destinationCode = null)
    {
        // validation for constraint: string
        if (!is_null($destinationCode) && !is_string($destinationCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($destinationCode)), __LINE__);
        }
        $this->destinationCode = $destinationCode;
        return $this;
    }
    /**
     * Get shipCode value
     * @return string|null
     */
    public function getShipCode()
    {
        return $this->shipCode;
    }
    /**
     * Set shipCode value
     * @param string $shipCode
     * @return \StructType\ListAvailableCruises
     */
    public function setShipCode($shipCode = null)
    {
        // validation for constraint: string
        if (!is_null($shipCode) && !is_string($shipCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($shipCode)), __LINE__);
        }
        $this->shipCode = $shipCode;
        return $this;
    }
    /**
     * Get portCode value
     * @return string|null
     */
    public function getPortCode()
    {
        return $this->portCode;
    }
    /**
     * Set portCode value
     * @param string $portCode
     * @return \StructType\ListAvailableCruises
     */
    public function setPortCode($portCode = null)
    {
        // validation for constraint: string
        if (!is_null($portCode) && !is_string($portCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($portCode)), __LINE__);
        }
        $this->portCode = $portCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ListAvailableCruises
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
