<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Privacy StructType
 * @subpackage Structs
 */
class Privacy extends AbstractStructBase
{
    /**
     * The Print
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $Print;
    /**
     * The PrivacyTDP
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $PrivacyTDP;
    /**
     * The PrivacyIM
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $PrivacyIM;
    /**
     * The PrivacyDAA
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $PrivacyDAA;
    /**
     * The ByPost
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $ByPost;
    /**
     * The ByEMail
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $ByEMail;
    /**
     * The ByPhone
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $ByPhone;
    /**
     * Constructor method for Privacy
     * @uses Privacy::setPrint()
     * @uses Privacy::setPrivacyTDP()
     * @uses Privacy::setPrivacyIM()
     * @uses Privacy::setPrivacyDAA()
     * @uses Privacy::setByPost()
     * @uses Privacy::setByEMail()
     * @uses Privacy::setByPhone()
     * @param bool $print
     * @param bool $privacyTDP
     * @param bool $privacyIM
     * @param bool $privacyDAA
     * @param bool $byPost
     * @param bool $byEMail
     * @param bool $byPhone
     */
    public function __construct($print = null, $privacyTDP = null, $privacyIM = null, $privacyDAA = null, $byPost = null, $byEMail = null, $byPhone = null)
    {
        $this
            ->setPrint($print)
            ->setPrivacyTDP($privacyTDP)
            ->setPrivacyIM($privacyIM)
            ->setPrivacyDAA($privacyDAA)
            ->setByPost($byPost)
            ->setByEMail($byEMail)
            ->setByPhone($byPhone);
    }
    /**
     * Get Print value
     * @return bool
     */
    public function getPrint()
    {
        return $this->Print;
    }
    /**
     * Set Print value
     * @param bool $print
     * @return \StructType\Privacy
     */
    public function setPrint($print = null)
    {
        // validation for constraint: boolean
        if (!is_null($print) && !is_bool($print)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($print)), __LINE__);
        }
        $this->Print = $print;
        return $this;
    }
    /**
     * Get PrivacyTDP value
     * @return bool
     */
    public function getPrivacyTDP()
    {
        return $this->PrivacyTDP;
    }
    /**
     * Set PrivacyTDP value
     * @param bool $privacyTDP
     * @return \StructType\Privacy
     */
    public function setPrivacyTDP($privacyTDP = null)
    {
        // validation for constraint: boolean
        if (!is_null($privacyTDP) && !is_bool($privacyTDP)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($privacyTDP)), __LINE__);
        }
        $this->PrivacyTDP = $privacyTDP;
        return $this;
    }
    /**
     * Get PrivacyIM value
     * @return bool
     */
    public function getPrivacyIM()
    {
        return $this->PrivacyIM;
    }
    /**
     * Set PrivacyIM value
     * @param bool $privacyIM
     * @return \StructType\Privacy
     */
    public function setPrivacyIM($privacyIM = null)
    {
        // validation for constraint: boolean
        if (!is_null($privacyIM) && !is_bool($privacyIM)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($privacyIM)), __LINE__);
        }
        $this->PrivacyIM = $privacyIM;
        return $this;
    }
    /**
     * Get PrivacyDAA value
     * @return bool
     */
    public function getPrivacyDAA()
    {
        return $this->PrivacyDAA;
    }
    /**
     * Set PrivacyDAA value
     * @param bool $privacyDAA
     * @return \StructType\Privacy
     */
    public function setPrivacyDAA($privacyDAA = null)
    {
        // validation for constraint: boolean
        if (!is_null($privacyDAA) && !is_bool($privacyDAA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($privacyDAA)), __LINE__);
        }
        $this->PrivacyDAA = $privacyDAA;
        return $this;
    }
    /**
     * Get ByPost value
     * @return bool
     */
    public function getByPost()
    {
        return $this->ByPost;
    }
    /**
     * Set ByPost value
     * @param bool $byPost
     * @return \StructType\Privacy
     */
    public function setByPost($byPost = null)
    {
        // validation for constraint: boolean
        if (!is_null($byPost) && !is_bool($byPost)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($byPost)), __LINE__);
        }
        $this->ByPost = $byPost;
        return $this;
    }
    /**
     * Get ByEMail value
     * @return bool
     */
    public function getByEMail()
    {
        return $this->ByEMail;
    }
    /**
     * Set ByEMail value
     * @param bool $byEMail
     * @return \StructType\Privacy
     */
    public function setByEMail($byEMail = null)
    {
        // validation for constraint: boolean
        if (!is_null($byEMail) && !is_bool($byEMail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($byEMail)), __LINE__);
        }
        $this->ByEMail = $byEMail;
        return $this;
    }
    /**
     * Get ByPhone value
     * @return bool
     */
    public function getByPhone()
    {
        return $this->ByPhone;
    }
    /**
     * Set ByPhone value
     * @param bool $byPhone
     * @return \StructType\Privacy
     */
    public function setByPhone($byPhone = null)
    {
        // validation for constraint: boolean
        if (!is_null($byPhone) && !is_bool($byPhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($byPhone)), __LINE__);
        }
        $this->ByPhone = $byPhone;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Privacy
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
