<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PrivacyInfo StructType
 * @subpackage Structs
 */
class PrivacyInfo extends AbstractStructBase
{
    /**
     * The PrivacyAuthorization
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $PrivacyAuthorization;
    /**
     * Constructor method for PrivacyInfo
     * @uses PrivacyInfo::setPrivacyAuthorization()
     * @param bool $privacyAuthorization
     */
    public function __construct($privacyAuthorization = null)
    {
        $this
            ->setPrivacyAuthorization($privacyAuthorization);
    }
    /**
     * Get PrivacyAuthorization value
     * @return bool
     */
    public function getPrivacyAuthorization()
    {
        return $this->PrivacyAuthorization;
    }
    /**
     * Set PrivacyAuthorization value
     * @param bool $privacyAuthorization
     * @return \StructType\PrivacyInfo
     */
    public function setPrivacyAuthorization($privacyAuthorization = null)
    {
        // validation for constraint: boolean
        if (!is_null($privacyAuthorization) && !is_bool($privacyAuthorization)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($privacyAuthorization)), __LINE__);
        }
        $this->PrivacyAuthorization = $privacyAuthorization;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PrivacyInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
