<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VoucherInfo StructType
 * @subpackage Structs
 */
class VoucherInfo extends AbstractStructBase
{
    /**
     * The SSVVoucherControl
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $SSVVoucherControl;
    /**
     * Constructor method for VoucherInfo
     * @uses VoucherInfo::setSSVVoucherControl()
     * @param string $sSVVoucherControl
     */
    public function __construct($sSVVoucherControl = null)
    {
        $this
            ->setSSVVoucherControl($sSVVoucherControl);
    }
    /**
     * Get SSVVoucherControl value
     * @return string
     */
    public function getSSVVoucherControl()
    {
        return $this->SSVVoucherControl;
    }
    /**
     * Set SSVVoucherControl value
     * @uses \EnumType\SSVVoucherControl::valueIsValid()
     * @uses \EnumType\SSVVoucherControl::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $sSVVoucherControl
     * @return \StructType\VoucherInfo
     */
    public function setSSVVoucherControl($sSVVoucherControl = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\SSVVoucherControl::valueIsValid($sSVVoucherControl)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $sSVVoucherControl, implode(', ', \EnumType\SSVVoucherControl::getValidValues())), __LINE__);
        }
        $this->SSVVoucherControl = $sSVVoucherControl;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\VoucherInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
