<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WebCheckIn StructType
 * @subpackage Structs
 */
class WebCheckIn extends AbstractStructBase
{
    /**
     * The SendAdvertising
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $SendAdvertising;
    /**
     * The EmergencyInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\EmercencyInfo
     */
    public $EmergencyInfo;
    /**
     * The AdditionalAdvertisingInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AdditionalAdvertisingInfo
     */
    public $AdditionalAdvertisingInfo;
    /**
     * Constructor method for WebCheckIn
     * @uses WebCheckIn::setSendAdvertising()
     * @uses WebCheckIn::setEmergencyInfo()
     * @uses WebCheckIn::setAdditionalAdvertisingInfo()
     * @param bool $sendAdvertising
     * @param \StructType\EmercencyInfo $emergencyInfo
     * @param \StructType\AdditionalAdvertisingInfo $additionalAdvertisingInfo
     */
    public function __construct($sendAdvertising = null, \StructType\EmercencyInfo $emergencyInfo = null, \StructType\AdditionalAdvertisingInfo $additionalAdvertisingInfo = null)
    {
        $this
            ->setSendAdvertising($sendAdvertising)
            ->setEmergencyInfo($emergencyInfo)
            ->setAdditionalAdvertisingInfo($additionalAdvertisingInfo);
    }
    /**
     * Get SendAdvertising value
     * @return bool
     */
    public function getSendAdvertising()
    {
        return $this->SendAdvertising;
    }
    /**
     * Set SendAdvertising value
     * @param bool $sendAdvertising
     * @return \StructType\WebCheckIn
     */
    public function setSendAdvertising($sendAdvertising = null)
    {
        // validation for constraint: boolean
        if (!is_null($sendAdvertising) && !is_bool($sendAdvertising)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sendAdvertising)), __LINE__);
        }
        $this->SendAdvertising = $sendAdvertising;
        return $this;
    }
    /**
     * Get EmergencyInfo value
     * @return \StructType\EmercencyInfo|null
     */
    public function getEmergencyInfo()
    {
        return $this->EmergencyInfo;
    }
    /**
     * Set EmergencyInfo value
     * @param \StructType\EmercencyInfo $emergencyInfo
     * @return \StructType\WebCheckIn
     */
    public function setEmergencyInfo(\StructType\EmercencyInfo $emergencyInfo = null)
    {
        $this->EmergencyInfo = $emergencyInfo;
        return $this;
    }
    /**
     * Get AdditionalAdvertisingInfo value
     * @return \StructType\AdditionalAdvertisingInfo|null
     */
    public function getAdditionalAdvertisingInfo()
    {
        return $this->AdditionalAdvertisingInfo;
    }
    /**
     * Set AdditionalAdvertisingInfo value
     * @param \StructType\AdditionalAdvertisingInfo $additionalAdvertisingInfo
     * @return \StructType\WebCheckIn
     */
    public function setAdditionalAdvertisingInfo(\StructType\AdditionalAdvertisingInfo $additionalAdvertisingInfo = null)
    {
        $this->AdditionalAdvertisingInfo = $additionalAdvertisingInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\WebCheckIn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
